use Time::HiRes qw( gettimeofday );

require './client/src/SOPGClassicMerchantClient.pl';

use constant {
    ENDPOINT => 'https://soatest.paysafecard.com/psc/services/PscService',
    USERNAME => 'USER_CLASSIC',
    PASSWORD => 'PASS',
    CURRENCY => 'EUR',
    AMOUNT => 0.01,
    OKURL => 'http://okurl',
    NOKURL => 'http://nokurl',
    PIN => '5000000000002517',
    MID => '1000001243',
    SERIALNUMBER => '5000000000002517;0.01',
    DISPOSITIONSTATE => 'S',
};

sub testCreateDisposition() {
  $mtid = gettimeofday();
  print "CreateDisposition: ";
  print checkResult(createDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           OKURL, 
                           NOKURL, 
                           undef, 
                           undef, 
                           undef));
}

sub testAssignCardToDisposition() {
  $mtid = gettimeofday();
  print "\nCreateDisposition: ";
  print checkResult(createDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           OKURL, 
                           NOKURL, 
                           undef, 
                           undef, 
                           undef));

  print "\nAssignCardToDisposition: ";
  print checkResult(assignCardToDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           PIN));
}

sub testAssignCardsToDisposition() {
  $mtid = gettimeofday();
  print "\nCreateDisposition: ";
  print checkResult(createDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           OKURL, 
                           NOKURL, 
                           undef, 
                           undef, 
                           undef));
  $card1_href->{pin} = '5000000000002517';
  $card2_href->{pin} = '5000000000002511';
  #$card2_href->{password} = 'testPass';
  @cards = ($card1_href, $card2_href);
  print "\nAssignCardsToDisposition: ";
  print checkResult(assignCardsToDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           undef, 
                           1, 
                           @cards));
}

sub testModifyDispositionValue() {
  $mtid = gettimeofday();
  print "\nCreateDisposition: ";
  print checkResult(createDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           OKURL, 
                           NOKURL, 
                           undef, 
                           undef, 
                           undef));
  print "\nAssignCardToDisposition: ";
  print checkResult(assignCardToDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           PIN));
  print "\nModifyDispositionValue: ";
  print checkResult(modifyDispositionValue(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY));
}

sub testGetSerialNumbers() {
  $mtid = gettimeofday();
  print "\nCreateDisposition: ";
  print checkResult(createDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           OKURL, 
                           NOKURL, 
                           undef, 
                           undef, 
                           undef));
  print "\nAssignCardToDisposition: ";
  print checkResult(assignCardToDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           PIN));
  print "\nGetSerialNumbers: ";
  print checkResult(getSerialNumbers(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           CURRENCY));
}

sub testGetDispositionRawState() {
  $mtid = gettimeofday();
  print "\nCreateDisposition: ";
  print checkResult(createDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           OKURL, 
                           NOKURL, 
                           undef, 
                           undef, 
                           undef));
  print "\nAssignCardToDisposition: ";
  print checkResult(assignCardToDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           PIN));
  print "\nGetDispositionRawState: ";
  print checkResult(getDispositionRawState(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           CURRENCY));
}

sub testExecuteDebit() {
  $mtid = gettimeofday();
  print "\nCreateDisposition: ";
  print checkResult(createDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           OKURL, 
                           NOKURL, 
                           undef, 
                           undef, 
                           undef));
  print "\nAssignCardToDisposition: ";
  print checkResult(assignCardToDisposition(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           PIN));
  print "\nExecuteDebit: ";
  print checkResult(executeDebit(
                           USERNAME, 
                           PASSWORD, 
                           $mtid, 
                           undef, 
                           AMOUNT, 
                           CURRENCY, 
                           1, 
                           undef));
}

sub testGetMid() {
  print "\nGetMid: ";
  print checkResult(getMid(
                         USERNAME, 
                         PASSWORD, 
                         CURRENCY));
}

# Creates a SOAP client connected to the given endpoint.
sub setup {
  $client = SOAP::Lite->proxy($_[0])->uri('pscservice');
}

# This is a utilty sub that check if the returned errorCode and resultCode from SOAP call were 0, meaning there was
# no error.
sub checkResult {
  if(defined($_[0] {'errorCode'}) 
           && $_[0]{'errorCode'} == 0 
           && defined($_[0]{'resultCode'})  
           && $_[0]{'resultCode'} == 0) {
    return "OK";
  } else {
    if(defined($_[0] {'errorCode'})) {
      return $_[0]{'errorCode'};
    }
    return "ERROR";
  }
}

# create our SOAP client
setup(ENDPOINT);

testCreateDisposition();
testAssignCardToDisposition();
testAssignCardsToDisposition();
testModifyDispositionValue();
testGetSerialNumbers();
testGetDispositionRawState();
testExecuteDebit();
testGetMid();
